function lpr_sse=LPDR_SSE(parameter, del, maxit, tol, lpr_ini)

%==========================================================================
%This function takes the log pd ratio at time T as given and iterate to
%compute the log pd ratio at time 0.
%==========================================================================
%Input: lpr_ini is the vector of log pd ratio at time TTT.
%Output:lpr_mat is a dim_mXdim_time matrix, where every column is the log 
%       pd ratio of the asset at a particular point in time_grid.
%==========================================================================
betta   = parameter.betta;
gama    = parameter.gama;

t_bar   = parameter.t_bar;
a_ou    = parameter.a_ou;
sig     = parameter.sig;
phi     = parameter.phi;
phi_2   = parameter.phi_2;
mud     = parameter.mud;
q_star  = parameter.q_star;

% del     = parameter.del_solu;
dim_m   = parameter.dim_m;
m_vec   = parameter.m_vec;

if nargin<4;
        lpr_ini=1/(betta-mud+t_bar)*ones(dim_m,1);
end

bmm_vec=betta+t_bar-mud+(1-phi)*(m_vec-t_bar);
bmm_vec=bmm_vec+(phi_2-1)*(gama*sig^2+(gama-1)/(a_ou+betta)*q_star);

mut_vec=a_ou*(m_vec-t_bar)+(gama-phi_2)*q_star;
mut_vec=mut_vec+(gama-1)/(a_ou+betta)*(q_star/sig)^2;   %This 

epsi=100;
jjj=1;
while (epsi>tol && jjj<maxit);
    fun_data = spdata(0,m_vec,lpr_ini,lpr_ini);
    lpr_deri = spvalue(m_vec,fun_data,1);
    temp_vec = -(bmm_vec+lpr_deri.*mut_vec)*del;
    temp_vec = temp_vec+0.5*del*(lpr_deri.^2)*(q_star/sig)^2;
    temp_vec = log(del+exp(lpr_ini+temp_vec));
    lpr_new  = temp_vec;
    epsi     = sqrt(sum((lpr_new-lpr_ini).^2)/dim_m);
    lpr_ini  = lpr_new;
    jjj=jjj+1;
    if (jjj/10000==floor(jjj/10000));
        disp(['Total Number of Iteration:   ', num2str(jjj), ...
            '  Residue:', num2str(epsi)]);
    end
end
lpr_sse      = lpr_new;
end