%==========================================================================
clear;
clc;
%==========================================================================
%This section sets the parameter values of the model
parameter.betta     = 0.02;
parameter.gama      = 10;
parameter.ssai      = 1;

parameter.t_bar     = 0.015;
parameter.a_ou      = 0.10;
parameter.sig       = sqrt(10)/100;
parameter.sig_t     = 0.15*parameter.sig;
% %=========================================
parameter.a_ou      = 0.05;
parameter.sig_t     = 0.08*parameter.sig;
% %=========================================
parameter.phi       = 4;   %Set phi=0.8 for bond; and 3 for equity
parameter.phi_2      = parameter.phi;
parameter.mud       = 0.015;

parameter.TTT       = 1/12;
parameter.dim_solu_time  = 31;
parameter.del_solu  = parameter.TTT/(parameter.dim_solu_time-1);
parameter.T_inf     = 30;
parameter.dim_inf_time = 1001;
parameter.del_inf   = parameter.T_inf/(parameter.dim_inf_time-1);

betta   = parameter.betta;
gama    = parameter.gama;

t_bar   = parameter.t_bar;  %stationary mean of theta
a_ou    = parameter.a_ou;   %mean reversion rate
sig_t   = parameter.sig_t;
sig     = parameter.sig;
phi     = parameter.phi;    %leverage
mud     = parameter.mud;    %average div growth rate
TTT     = parameter.TTT;    %terminal time at which information revealed
dim_solu_time= parameter.dim_solu_time; %dim of time in the solution
del_solu     = parameter.del_solu;      %time interval in mc approximation
T_inf   = parameter.T_inf;
dim_inf_time = parameter.dim_inf_time;
del_inf = parameter.del_inf;

t_var   = sig_t^2/2/a_ou;         %Variance of the SSE distribution of theta
t_low   = t_bar-5*sqrt(t_var);   %Lower boundary of theta (5 std above)
t_hig   = t_bar+5*sqrt(t_var);   %Upper boundary of theta (5 std below)
dim_m   = 21; %To produce the figure for pdratio, we set dim_m=75, and mind_select=34.
m_vec   = linspace(t_low, t_hig, dim_m)';  %Vector of poterior mean of theta

a_hat   = sqrt(a_ou^2+(sig_t/sig)^2);
q_star  = sig_t^2/(a_ou+a_hat);    %sse posterior variance of theta
% q_ini   = q_star*0.5;
q_ini   = 0;
time_solu_grid  = linspace(0,TTT,dim_solu_time)';    %Vector of time used to solve the model
q_solu_grid     = Q_Grid(q_ini, time_solu_grid, parameter,'repeat');%Vector of Q associated with time_solu_grid
time_inf_grid  = linspace(0,T_inf,dim_inf_time)';    %Vector of time used to solve the model
q_inf_grid     = Q_Grid(0, time_inf_grid, parameter, 'infity');%Vector of Q associated with time_solu_grid
q_TTT   = q_solu_grid(dim_solu_time);

parameter.t_low = t_low;
parameter.t_hig = t_hig;
parameter.m_vec = m_vec;
parameter.dim_m = dim_m;
parameter.time_solu_grid= time_solu_grid;
parameter.q_solu_grid   = q_solu_grid;
parameter.time_inf_grid= time_inf_grid;

parameter.q_inf_grid   = q_inf_grid;
parameter.q_ini = q_ini;
parameter.q_star= q_star;
parameter.q_TTT = q_TTT;

%==========================================================================
%Solving the model with recursive utility
update_solution('recurs', parameter);
load pdr_solu lpr_mat fun_data_mat lpr_sse lpr_comp lpr_ini;

plot_ann_premium(4, 5, 12, 3, 'recurs', parameter);
% % % ==========================================================================