function update_solution(pref_case, parameter)

switch pref_case
    case 'expect';
        parameter.gama  = 0.999999;
        parameter.ssai  = 1.0;
end


betta   = parameter.betta;
t_bar   = parameter.t_bar;  %stationary mean of theta
mud     = parameter.mud;    %average div growth rate

m_vec   = parameter.m_vec;
dim_m   = parameter.dim_m;
dim_solu_time= parameter.dim_solu_time; %dim of time in the solution

%==========================================================================
pdr_vec = 1/(betta-mud+t_bar)*ones(dim_m,1);
lpr_termi=log(pdr_vec);

%Log pd ratio in an economy with learning steady-state.
lpr_sse     = LPDR_SSE(parameter, 0.01, 100000, 1.e-9, lpr_termi);
lpr_sse     = LPDR_SSE(parameter, 1.e-4, 100000, 1.e-9, lpr_sse);

% %Log pd ratio in an economy with complete information.
lpr_comp    = LPDR_CompInfo(parameter, 0.01, 100000, 1.e-9, lpr_sse);
lpr_comp    = LPDR_CompInfo(parameter, 1.e-4, 100000, 1.e-9, lpr_comp);

%Log pd ratio at date 0 with theta known, but unobservable afterwards.
lpr_ini     = LPDR_0(lpr_sse, parameter, 'infity');


lpr_mat     = Solve_pdr(lpr_termi, parameter, 15000, 1.e-9);
fun_data_mat= zeros(2*(dim_m-1)+1, 4, dim_solu_time);
for t_ind   = 1:dim_solu_time;
      lpr   = lpr_mat(:,t_ind);
      fun_data_mat(:,:,t_ind) = spdata(0,m_vec,lpr,lpr);
end
fun_data_comp=spdata(0,m_vec,lpr_comp,lpr_comp);
switch pref_case
    case 'expect';
        save pdr_solu_exp lpr_mat fun_data_mat fun_data_comp lpr_sse lpr_comp lpr_ini;
    case 'recurs';
        save pdr_solu lpr_mat fun_data_mat fun_data_comp lpr_sse lpr_comp lpr_ini;
end

end